/// <reference types="jest" />
import Lazy from './jest_rspec_styles/lazy_variables/lazy.interface';
import Subject from './jest_rspec_styles/lazy_variables/subject.interface';
import SharedExamples from './jest_rspec_styles/shared_examples/shared_examples.interface';
import IncludeExamples from './jest_rspec_styles/shared_examples/include_examples.interface';
import Allow from './jest_rspec_styles/mocks/allow.interface';
import Expect from './jest_rspec_styles/mocks/expect.interface';
import IMatcher from './jest_rspec_styles/matchers/matchers.interface';
import ExpectedStubChain from './jest_rspec_styles/mocks/expected_stub_chain';
/**
 * Global extension.
 */
declare global {
    var context: jest.Describe;
    var lazy: Lazy;
    var subject: Subject;
    var sharedExamples: SharedExamples;
    var includeExamples: IncludeExamples;
    var allow: Allow;
    var allowAnyInstanceOf: Allow;
    var expectAnyInstanceOf: Expect;
    namespace jest {
        interface Matchers<R> extends IMatcher<R> {
            toReceive(method: string): ExpectedStubChain;
        }
    }
}
/**
 * RSpec style extension for jest.
 *
 * @example
 * import JestRSpecStyle from 'jest-rspec-style';
 * JestRSpecStyle.setup();
 */
export default class JestRSpecStyle {
    private static _lazy;
    private static _sharedExample;
    private static _mock;
    private static _matcher;
    /**
     * Setup plugin.
     */
    static setup(): void;
    /**
     * Reset status.
     */
    private static _reset;
    /**
     * Verify status.
     */
    private static _verify;
}
