/**
 * Tracker of jest status.
 */
export default class JestTracker {
    private _currentSpec;
    /**
     * Initialize trakcer.
     */
    constructor();
    /**
     * Get current suite.
     * @param {jasmine.Suite} suite Suite (Must not set, for recursive process.)
     * @return {jasmine.Suite} Current suite.
     */
    getCurrentSuite(suite?: jasmine.Suite): jasmine.Suite;
    /**
     * Find a owner suite of a spec.
     * @param {jasmine.Spec}  spec  Spec.
     * @param {jasmine.Suite} suite Suite (Must not set, for recursive process.)
     * @return {jasmine.Suite} Owner suite of a spec
     */
    private _findOwnerSuite;
    /**
     * Process start event.
     * @param {jasmine.Spec} spec Starting spec.
     */
    private _onStart;
    /**
     * Process finish event.
     */
    private _onEnd;
    /**
     * Create event hooks.
     */
    private _createEventHooks;
    /**
     * Inject onStart hook to spec.
     * @param {jasmine.Suite | jasmine.Spec} context コンテキスト
     */
    private _injectOnStartHookToAllSpec;
}
