import JestTracker from './jest_tracker';
/**
 * Lazy Variable.
 */
export default class LazyVariable {
    private _definitions;
    private _caches;
    private _tracker;
    /**
     * Initialize.
     * @param {JestTracker} tracker tracker of jest
     */
    constructor(tracker: JestTracker);
    /**
     * Reset status.
     */
    reset(): void;
    /**
     * Create lazy variable.
     * @param {string}   name      name of variable.
     * @param {Function} evaluator function of variable evaluator. (If omit, get lazy variable.)
     * @return {Object} evaluated value.
     */
    lazy(name: string, evaluator?: () => any): any;
    /**
     * Create subject of test.
     * @param {Function} evaluator function of variable evaluator. (If omit, get lazy variable.)
     * @return {Object} evaluated value.
     */
    subject(evaluator?: () => any): any;
}
