/**
 * Definition of lazy variable.
 */
export default class Definition {
    private _name;
    private _evaluator;
    private _suiteId;
    /**
     * Initialize
     * @param {string}   name      name of variable.
     * @param {Function} evaluator function of evaluation.
     * @param {string}   suiteId   id of suite.
     */
    constructor(name: string, evaluator: () => any, suiteId: string);
    /**
     * Get a name of variable.
     * @return {String} name of variable.
     */
    get name(): string;
    /**
     * Get a id of suite.
     * @return {String} id of suite.
     */
    get suiteId(): string;
    /**
     * Evaluate lazy variable.
     * @return {any} evaluated value.
     */
    eval(): any;
}
