"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const change_1 = __importDefault(require("./matchers/change"));
/**
 * Matchers
 */
class default_1 {
    /**
     * Initialize.
     * @param {Mock} mock tracker of jest
     */
    constructor(mock) {
        this._mock = mock;
        this._expect = expect;
    }
    /**
     * Setup matchers.
     */
    setup() {
        this._extendExpect();
        this._extendJestMatchers();
    }
    /**
     * Exptend expect method.
     */
    _extendExpect() {
        const expect = ((actual) => {
            const original = this._expect(actual);
            const matchers = { ...original, toReceive: (method) => {
                    return this._mock.expect(actual).toReceive(method);
                },
                not: { ...original.not, toReceive: (method) => {
                        return matchers.toReceive(method).not();
                    },
                },
            };
            return matchers;
        });
        global.expect = Object.assign(expect, this._expect);
    }
    /**
     * Extend jest matchers.
     */
    _extendJestMatchers() {
        expect.extend({
            toChange: change_1.default,
        });
    }
}
exports.default = default_1;
//# sourceMappingURL=matcher.js.map