/// <reference types="jest" />
export interface ChangeOptionsParamter {
    from?: any;
    to?: any;
}
/**
 * Change matcher is used to specify that a function return value changes some mutable state.
 * @param {Object}   actual Action.
 * @param {Function} receiver       Function that return test value.
 * @param {Object}   options  Options. { from, to }
 * @return {Promise|Object} Result.
 */
export default function (actual: () => any, receiver: () => any, options?: ChangeOptionsParamter): jest.CustomMatcherResult | Promise<jest.CustomMatcherResult>;
