import ExpectedStubChain from './mocks/expected_stub_chain';
import StubChain from './mocks/stub_chain';
/**
 * Stub
 */
export default class Mock {
    private _stubChains;
    /**
     * Stub object.
     * @param {Object} target Stub target.
     * @return {StubChain} Stub hain.
     */
    allow(target: any): StubChain;
    /**
     * Stub all instance of object.
     * @param {Object} target Stub target.
     * @return {StubChain} Stub hain.
     */
    allowAnyInstanceOf(target: any): StubChain;
    /**
     * Expect and stub object.
     * @param {Object} target Stub target.
     * @return {StubChain} Stub hain.
     */
    expect(target: any): ExpectedStubChain;
    /**
     * Expect and stub all instance of object.
     * @param {Object} target Stub target.
     * @return {StubChain} Stub hain.
     */
    expectAnyInstanceOf(target: any): ExpectedStubChain;
    /**
     * Reet stubs.
     */
    reset(): void;
    /**
     * Verify stub chains.
     */
    verify(): void;
}
