import StubChain from './stub_chain';
/**
 * Expected call stub chain.
 */
export default class ExpectedStubChain extends StubChain {
    private _isNot;
    private _with;
    private _times;
    /**
     * Expect not calling.
     * @return {this} chain instance.
     */
    not(): this;
    /**
     * Expect calling times.
     * @param {Number} times Times of calling.
     * @return {this} chain instance.
     */
    times(times: number): this;
    /**
     * Expect calling args.
     * @param {Array<Object>} args Arguments of calling.
     * @return {this} chain instance.
     */
    with(...args: any): this;
    /**
     * Verify calling state.
     * @abstract
     * @throws on fail.
     */
    verify(): void;
}
