/// <reference types="jest" />
/**
 * Stub chain.
 */
export default class StubChain {
    private _target;
    private _original?;
    private _returningValue;
    private _function?;
    protected _mock?: jest.MockInstance<any, any>;
    /**
     * Initialize
     * @param {Object} target Stub target.
     */
    constructor(target: any);
    /**
     * Call original implementation.
     * @return {this} chain instance.
     */
    andCallOriginal(): this;
    /**
     * Set returning value.
     * @param {Object} value returning value
     * @return {this} chain instance.
     */
    andReturn(value: any): this;
    /**
     * Set execute function.
     * @param {Function} func function.
     * @return {this} chain instance.
     */
    do(func: (...args: any) => any): this;
    /**
     * Mock method.
     * @param {string} method name of method.
     * @return {this} chain instance;
     */
    toReceive(method: string): this;
    /**
     * Mock method chain.
     * @param {string} methods name of method.
     * @return {this} chain instance;
     */
    toReceiveMessageChain(...methods: [string]): this;
    /**
     * Verify calling state.
     * @abstract
     * @throws on fail.
     */
    verify(): void;
}
